<?php
/**
 * @author DevIK
 *
 * */

use Tygh\Tools\Url;
use Tygh\Http;

if ($mode === 'update') {
    $boxberryServiceIdsArray = db_get_fields(
        '
            SELECT `service_id`
            FROM ?:shipping_services
            WHERE module = "boxberry"
        '
    );

    if (isset($_POST['shipping_data']['service_id']) && in_array($_POST['shipping_data']['service_id'], $boxberryServiceIdsArray)) {
        if (isset($_REQUEST['boxberry_selected_point']) && is_array($_REQUEST['boxberry_selected_point'])) {
            foreach ($_REQUEST['boxberry_selected_point'] as $group_id => $shippings) {
                if (!is_array($shippings)) {
                    continue;
                }
                foreach ($shippings as $shipping_id => $boxberry_point) {
                    if (strlen($boxberry_point) > 0) {
                        Tygh::$app['session']['cart']['shippings_extra']['boxberry'][$group_id][$shipping_id]['point_id'] = $boxberry_point;
                    }
                }
            }
        }

        if (isset($_POST['shipping_data']['service_params']) && $_POST['shipping_data']['service_params']['password'] === '') {
            fn_set_notification('E', fn_get_lang_var('Error'), 'Укажите токен!');
        } elseif (isset($_POST['shipping_data']['service_params']) && $_POST['shipping_data']['service_params']['api_url'] === '') {
            fn_set_notification('E', fn_get_lang_var('Error'), 'Укажите Url для API!');
        } elseif (isset($_POST['shipping_data']['service_params']) && $_POST['shipping_data']['service_params']['widget_url'] === '') {
            fn_set_notification('E', fn_get_lang_var('Error'), 'Укажите Url для виджета!');
        } elseif (isset($_POST['shipping_data']['service_params']) && $_POST['shipping_data']['service_params']['api_url'] !== '' && $_POST['shipping_data']['service_params']['widget_url'] !== '') {

            $urlParams = [
                'token' => $_POST['shipping_data']['service_params']['password'],
                'method' => 'GetKeyIntegration',
            ];

            $result = Http::get($_POST['shipping_data']['service_params']['api_url'], $urlParams);

            $statusCode = Http::getStatus();

            if ($statusCode !== 200 && $statusCode !== 401) {
                fn_set_notification('E', fn_get_lang_var('Error'), 'Неверный Url для Api');
            } elseif ($statusCode === 401) {
                fn_set_notification('E', fn_get_lang_var('Error'), 'Невалидный API token');
            } else {
                $res = json_decode($result, true);
                if (isset($res[0]['err']) && !empty($res[0]['err'])) {
                    fn_set_notification('E', fn_get_lang_var('Error'), $res[0]['err']);
                } else {
                    $update_values = null;
                    $boxberry_name = 'boxberry';
                    $boxberry_services = db_get_array(
                        '
                        SELECT `service_params`,`shipping_id`
                        FROM ?:shipping_services
                        INNER JOIN ?:shippings
                        ON ?:shipping_services.service_id = ?:shippings.service_id
                        WHERE module = ?s ORDER BY `service_params` DESC',
                        $boxberry_name
                    );
                    foreach ($boxberry_services as $params) {
                        $shipping_id = $params["shipping_id"];
                        $service_params = unserialize($params["service_params"]);

                        if (isset($service_params['password']) && !empty($service_params['password'])) {
                            $update_values['service_params'] = $service_params;
                        } else {
                            if (!empty($update_values)) {
                                fn_update_shipping($update_values, $shipping_id);
                            }
                        }
                    }
                }
            }
        }
    }
}

