(function (_, $) {
    let bbDispatch = false;
    let boxberryPointCode = false;
    let boxberryCityName = false;
    let csCartCityName = false;

    $.ceEvent('on', 'ce.commoninit', function (context) {
        csCartCityName = Tygh.$("[name='user_data[s_city]']").length ? Tygh.$("[name='user_data[s_city]']").val() : false;
        bbDispatch = Tygh.$('.litecheckout').length ? 'checkout.update' : 'checkout.update_steps';
        checkSelectedCity()

    });

    $.ceEvent('on', 'ce.ajaxdone', function() {
        checkSelectedCity()
    });

    function checkSelectedCity() {
        if (csCartCityName && boxberryCityName && boxberryPointCode) {
            if (csCartCityName.toLowerCase().replace('ё','е').indexOf(boxberryCityName.toLowerCase().replace('ё','е')) === -1) {
                boxberryCityName = false;
                let pointId = Tygh.$('input[name^="boxberry_selected_point[0]"]').length ? Tygh.$('input[name^="boxberry_selected_point[0]"]') : false;
                let cityName = Tygh.$('input[name^="boxberry_selected_point_full_name[0]"]').length ? Tygh.$('input[name^="boxberry_selected_point_full_name[0]"]') : false;
                if (pointId && cityName) {
                    let data = {}
                    data[pointId.attr('name')] = 'unselect_pvz';
                    data[cityName.attr('name')] = Tygh.tr('boxberry.select_pickup_point');
                    bxbAjaxPost(data)
                }
            }
        }
    }

    (function (window, document, undefined) {
        let firstScriptElement = document.getElementsByTagName("script")[0];
        let scriptElement = document.createElement("script");
        let placeWidgetScript = function () {
            firstScriptElement.parentNode.insertBefore(scriptElement, firstScriptElement);
        };
        let widget_src = "//points.boxberry.de/js/boxberry.js";

        if ($('.bxb_link').data('widget_url')) {
            widget_src = $('.bxb_link').data('widget_url');
        }

        scriptElement.type = "text/javascript";
        scriptElement.src = widget_src;
        if (window.opera == "[object Opera]") {
            document.addEventListener("DOMContentLoaded", placeWidgetScript, false);
        } else {
            placeWidgetScript();
        }
        document.addEventListener('click', function (e) {
            if (e.target && (e.target instanceof HTMLElement) && e.target.getAttribute('data-boxberry-open') === 'true') {
                e.preventDefault();
                var selectPointLink = e.target;
                (function (selectedPointLink) {
                    let city = selectPointLink.getAttribute('data-boxberry-city').replace('ё','е') || undefined;
                    let token = selectPointLink.getAttribute('data-boxberry-token');
                    let weight = selectedPointLink.getAttribute('data-boxberry-weight');
                    let length = selectedPointLink.getAttribute('data-boxberry-length');
                    let width = selectedPointLink.getAttribute('data-boxberry-width');
                    let height = selectedPointLink.getAttribute('data-boxberry-height');
                    let callbackInputAttr = selectPointLink.getAttribute('data-boxberry-point-input');
                    let callbackFullNameInputAttr = selectPointLink.getAttribute('data-boxberry-point-full-name-input');
                    let paymentSum = selectPointLink.getAttribute('data-paymentsum');
                    let orderSum = selectPointLink.getAttribute('data-ordersum');
                    let apiUrl = selectPointLink.getAttribute('data-api_url');
                    let sucrh = selectPointLink.getAttribute('data-sucrh');
                    let callbackInput;
                    let callbackFullNameInput;
                    if (callbackInputAttr[0] === '#') {
                        callbackInput = document.getElementById(callbackInputAttr.substr(1));
                    } else {
                        callbackInput = document.getElementsByName(callbackInputAttr).item(0);
                    }
                    if (callbackFullNameInputAttr[0] === '#') {
                        callbackFullNameInput = document.getElementById(callbackFullNameInputAttr.substr(1));
                    } else {
                        callbackFullNameInput = document.getElementsByName(callbackFullNameInputAttr).item(0);
                    }

                    if (typeof (callbackFullNameInput) === 'undefined' || callbackFullNameInput === null) {
                        let inp_id = document.getElementById('selected_point_id');
                        let input_bxb_name = inp_id.name;
                        let input_full_name = input_bxb_name.replace('boxberry_selected_point', 'boxberry_selected_point_full_name');
                        callbackFullNameInput = document.createElement("input");
                        callbackFullNameInput.type = "hidden";
                        callbackFullNameInput.name = input_full_name;
                        document.getElementsByTagName('BODY')[0].appendChild(callbackFullNameInput);
                    }

                    let boxberryPointSelectedHandler = function (result) {
                        boxberryPointCode = result.id;
                        boxberryCityName = result.name;
                        let selectedPointName = boxberryCityName + ' (' + result.address + ')';
                        selectedPointLink.textContent = selectedPointName;
                        callbackFullNameInput.value = selectedPointName;
                        callbackInput.value = boxberryPointCode;
                        let data = {};
                        data[callbackInput.getAttribute('name')] = boxberryPointCode;
                        data[callbackFullNameInput.getAttribute('name')] = selectedPointName;
                        $("input[name='user_data[s_address]']").val(result.address);
                        bxbAjaxPost(data)
                    };

                    boxberry.versionAPI(apiUrl);
                    boxberry.checkLocation(1);
                    boxberry.sucrh(sucrh);
                    boxberry.open(boxberryPointSelectedHandler, token, city, '', orderSum, weight, paymentSum, height, width, length);
                })(selectPointLink);
            }
        }, true);
    })(window, document, undefined);

    function bxbAjaxPost(data) {
        $.ceAjax('request', fn_url(bbDispatch), {
            method: 'post',
            caching: false,
            recalculate: true,
            data: data,
            callback: function () {
                fn_calculate_total_shipping_cost();
            }
        });
    }

    function token_callback(result) {
        shipping_id = $('form[name="shippings_form"]').find(('input[name="shipping_id"]')).val();
        if (result.token != undefined) {
            api_token_input = document.getElementById("password");
            reg_link = document.getElementById("reg_to_boxberry");
            api_token_input.value = result.token;
            $.ceAjax('request', fn_url('boxberry.save_token'), {
                method: 'post',
                caching: false,
                data: {token: result.token, shipping_id: shipping_id},
                callback: function () {
                    reg_link.remove();
                }
            });
        }
    }

    function callback_backend(result) {
        order_id = $('form[name="order_info_form"]').find('input[name="order_id"]').val();
        $.ceAjax('request', fn_url('orders.update_details'), {
            method: 'post',
            caching: false,
            data: {'point_id': result.id, 'order_id': order_id},
            callback: function () {
                $('.bxb_office_number').html(result.id);
            }
        });
    }
}(Tygh, Tygh.$));